# -*- mode: rpm-spec; indent-tabs-mode: nil -*-
#========================================================================
%global debug_package %{nil}

%define    ldas_tools_cmake_ver 1.2.3
%define    ldas_tools_al_ver    2.6.7
%define    basename_            ldas-tools-al
%define    name                 %{basename_}-swig
%define    hdr_dir              ldastoolsal
%define    tarbasename          ldas-tools-al-swig
%define    version              2.6.9
%define    release              1
%define    _docdir              %{_datadir}/doc/%{name}-%{version}

%define check_cmake3  ( 0%{?rhel} && 0%{?rhel} <= 7 )
%define check_python2 ( 0%{?rhel} && 0%{?rhel} <= 7 )
%define check_python3 ( 0%{?__python3:1} || ( 0%{?rhel} >= 7 ) )

#------------------------------------------------------------------------
Name:      %{name}
Summary:   LDAS tools abstraction toolkit language buildings
Version:   %{version}
Release:   %{release}%{?dist}
License:   GPLv2+
URL:       "https://wiki.ligo.org/Computing/LDASTools"
Group:     Application/Scientific
Conflicts: ldas-tools-al <= 2.6.1
Prefix:    %_prefix
BuildRoot: %{buildroot}
Source0:   https://software.igwn.org/lscsoft/source/%{tarbasename}-%{version}.tar.gz

#------------------------------------------------------------------------

%if %{check_cmake3}
BuildRequires: cmake3 >= 3.6
BuildRequires: cmake
%else
BuildRequires: cmake >= 3.6
%endif
BuildRequires: gawk
BuildRequires: gcc, gcc-c++, glibc
BuildRequires: make
BuildRequires: pkgconfig
BuildRequires: python3-rpm-macros
BuildRequires: rpm-build
BuildRequires: swig >= 3.0.7
BuildRequires: ldas-tools-cmake >= %{ldas_tools_cmake_ver}
BuildRequires: %{basename_}-devel >= %{ldas_tools_al_ver}

%if %check_python2
#........................................................................
# Python dependencies
#........................................................................
BuildRequires: python2
BuildRequires: python2-devel
%endif
#........................................................................
# Python 3 dependencies
#........................................................................
BuildRequires: python3
BuildRequires: python3-devel
#........................................................................
# Runtime dependencies
#........................................................................
Requires: %{basename_}-devel

%description
This provides the runtime libraries for the abstaction library.

%if %check_python2
#========================================================================
%package -n python2-%{basename_}
Summary: LDAS Tools %{name_desc} toolkit python %{python2_version} bindings
#........................................................................
# Runtime dependencies
#........................................................................
Requires: ldas-tools-al >= %{ldas_tools_al_ver}
Requires: python2

%description -n  python2-%{basename_}
This provides the python%{python2_version} bindings for the %{name_desc} library
%endif

#========================================================================
%package -n python%{python3_pkgversion}-%{basename_}
Summary:   LDAS tools abstraction toolkit language buildings
#........................................................................
# Runtime dependencies
#........................................................................
Requires: ldas-tools-al >= %{ldas_tools_al_ver}
Requires: python3

%description -n  python%{python3_pkgversion}-%{basename_}
This provides the runtime libraries for the abstaction library.

%prep
%setup -c -T -D -a 0 -n %{name}-%{version}

%build
%if %check_python2
export PYTHON2_BUILD_OPTS="-DENABLE_SWIG_PYTHON2=YES -DPYTHON2_EXECUTABLE=%{__python2}"
%else
export PYTHON2_BUILD_OPTS="-DENABLE_SWIG_PYTHON2=NO"
%endif
%if %check_python3
export PYTHON3_BUILD_OPTS="-DENABLE_SWIG_PYTHON3=YES -DPYTHON3_EXECUTABLE=%{__python3}"
%else
export PYTHON3_BUILD_OPTS="-DENABLE_SWIG_PYTHON3=NO"
%endif

%if %{check_cmake3}
export CMAKE_PROGRAM=cmake3
%else
export CMAKE_PROGRAM=cmake
%endif

${CMAKE_PROGRAM} \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo -DCMAKE_EXPORT_COMPILE_COMMANDS=1 \
    -DCMAKE_INSTALL_PREFIX=%{_prefix} \
    -DCMAKE_INSTALL_DOCDIR=%{_docdir} \
    ${PYTHON2_BUILD_OPTS} \
    ${PYTHON3_BUILD_OPTS} \
    %{tarbasename}-%{version}

%install
%if %{check_cmake3}
export CMAKE_PROGRAM=cmake3
%else
export CMAKE_PROGRAM=cmake
%endif

${CMAKE_PROGRAM} --build . --target install -- DESTDIR=%{buildroot}

%check
%if %{check_cmake3}
export CTEST_PROGRAM=ctest3
%else
export CTEST_PROGRAM=ctest
%endif

${CTEST_PROGRAM} -V %{?_smp_mflags}

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%{_includedir}/%{hdr_dir}/*.i

%if %check_python2
%files -n python2-%{basename_}
%defattr(-,root,root,-)
%{_libdir}/python2*
%endif

%files -n python%{python3_pkgversion}-%{basename_}
%defattr(-,root,root,-)
%{_libdir}/python3*

%changelog
* Wed Sep 29 2021 Edward Maros <ed.maros@ligo.org> - 2.6.9-1
- Built for new release

* Tue Mar 9 2021 Edward Maros <ed.maros@ligo.org> - 2.6.8-1
- Built for new release

* Wed Aug 14 2019 Edward Maros <ed.maros@ligo.org> - 2.6.7-1
- Built for new release

* Tue Nov 27 2018 Edward Maros <ed.maros@ligo.org> - 2.6.5-1
- Built for new release

* Tue Oct 11 2011 Edward Maros <emaros@ligo.caltech.edu> - 1.19.13-1
- Initial build.
